package com.example;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.zip.GZIPInputStream;

public class Main {
	
	public static void main(String[] args) throws IOException {
		//
		// 文字列を圧縮する
		//
		String s = "Hello, World!!";
		byte[] b = s.getBytes();

		byte[] data = Zopfli.compress(b);
		
		//
		// 圧縮したデータをJava標準のGZIPInputStreamで展開する
		//
		try(GZIPInputStream in = new GZIPInputStream(new ByteArrayInputStream(data))) {
			byte[] b2 = in.readAllBytes();
			String s2 = new String(b2);
			System.out.println(s2);
		}
		
		//
		// ファイルを圧縮する
		//
		File input  = new File("yahoo-top-page.html");
		File output = new File("yahoo-top-page.html.gz");
		
		try(InputStream in = new FileInputStream(input);
				OutputStream out = new FileOutputStream(output)) {
			out.write(Zopfli.compress(in.readAllBytes()));
		}
	}
}
